Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3116)
@@ -11,9 +11,11 @@
    !!   'key_bdy'                     Unstructured Open Boundary Conditions
    !!----------------------------------------------------------------------
-   !!   bdy_tra_frs        : Relaxation of tracers on unstructured open boundaries
+   !!   bdy_tra            : Apply open boundary conditions to T and S
+   !!   bdy_tra_frs        : Apply Flow Relaxation Scheme
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
    USE bdy_oce         ! ocean open boundary conditions
+   USE bdydta, ONLY:   bf
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
@@ -22,5 +24,5 @@
    PRIVATE
 
-   PUBLIC bdy_tra_frs     ! routine called in tranxt.F90 
+   PUBLIC bdy_tra      ! routine called in tranxt.F90 
 
    !!----------------------------------------------------------------------
@@ -31,14 +33,40 @@
 CONTAINS
 
-   SUBROUTINE bdy_tra_frs( kt )
+   SUBROUTINE bdy_tra( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  SUBROUTINE bdy_dyn3d  ***
+      !!
+      !! ** Purpose : - Apply open boundary conditions for baroclinic velocities
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) :: kt     ! Main time step counter
+      !!
+      INTEGER               :: ib_bdy ! Loop index
+
+      DO ib_bdy=1, nb_bdy
+
+         SELECT CASE( nn_tra(ib_bdy) )
+         CASE(jp_none)
+            CYCLE
+         CASE(jp_frs)
+            CALL bdy_tra_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+         CASE DEFAULT
+            CALL ctl_stop( 'bdy_tra : unrecognised option for open boundaries for T and S' )
+         END SELECT
+      ENDDO
+
+   END SUBROUTINE bdy_tra
+
+   SUBROUTINE bdy_tra_frs( idx, dta, kt )
       !!----------------------------------------------------------------------
       !!                 ***  SUBROUTINE bdy_tra_frs  ***
       !!                    
-      !! ** Purpose : Apply the Flow Relaxation Scheme for tracers in the  
-      !!              case of unstructured open boundaries.
+      !! ** Purpose : Apply the Flow Relaxation Scheme for tracers at open boundaries.
       !! 
       !! Reference : Engedahl H., 1995, Tellus, 365-382.
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt
+      INTEGER,         INTENT(in) ::   kt
+      TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
       !! 
       REAL(wp) ::   zwgt           ! boundary weight
@@ -47,28 +75,20 @@
       !!----------------------------------------------------------------------
       !
-      IF(ln_tra_frs) THEN       ! If this is false, then this routine does nothing. 
-         !
-         IF( kt == nit000 ) THEN
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) 'bdy_tra_frs : Flow Relaxation Scheme for tracers'
-            IF(lwp) WRITE(numout,*) '~~~~~~~'
-         ENDIF
-         !
-         igrd = 1                       ! Everything is at T-points here
-         DO ib = 1, nblen(igrd)
-            DO ik = 1, jpkm1
-               ii = nbi(ib,igrd)
-               ij = nbj(ib,igrd)
-               zwgt = nbw(ib,igrd)
-               tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) * (1.-zwgt) + tbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)         
-               tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) * (1.-zwgt) + sbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)
-            END DO
-         END DO 
-         !                                              ! Boundary points should be updated
-         CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )     
-         CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    
-         !
-      ENDIF ! ln_tra_frs
       !
+      igrd = 1                       ! Everything is at T-points here
+      DO ib = 1, idx%nblen(igrd)
+         DO ik = 1, jpkm1
+            ii = idx%nbi(ib,igrd)
+            ij = idx%nbj(ib,igrd)
+            zwgt = idx%nbw(ib,igrd)
+            tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) + zwgt * ( dta%tem(ib,ik) - tsa(ii,ij,ik,jp_tem) ) ) * tmask(ii,ij,ik)         
+            tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) + zwgt * ( dta%sal(ib,ik) - tsa(ii,ij,ik,jp_sal) ) ) * tmask(ii,ij,ik)
+         END DO
+      END DO 
+      !
+      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
+      !
+      IF( kt .eq. nit000 ) CLOSE( unit = 102 )
+   !
    END SUBROUTINE bdy_tra_frs
    
@@ -78,7 +98,7 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE bdy_tra_frs(kt)      ! Empty routine
-      WRITE(*,*) 'bdy_tra_frs: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_tra_frs
+   SUBROUTINE bdy_tra(kt)      ! Empty routine
+      WRITE(*,*) 'bdy_tra: You should not have seen this print! error?', kt
+   END SUBROUTINE bdy_tra
 #endif
 
Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 3116)
@@ -71,6 +71,7 @@
       !!
       INTEGER  ::   ji, jj, jk, jb, jgrd
-      INTEGER  ::   ii, ij
+      INTEGER  ::   ib_bdy, ii, ij
       REAL(wp) ::   zubtpecor, z_cflxemp, ztranst
+      TYPE(OBC_INDEX), POINTER :: idx
       !!-----------------------------------------------------------------------------
 
@@ -91,19 +92,24 @@
       ! ------------------------------------------------
       zubtpecor = 0.e0
-      jgrd = 2                               ! cumulate u component contribution first 
-      DO jb = 1, nblenrim(jgrd)
-         DO jk = 1, jpkm1
-            ii = nbi(jb,jgrd)
-            ij = nbj(jb,jgrd)
-            zubtpecor = zubtpecor + flagu(jb) * ua(ii,ij, jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+      DO ib_bdy = 1, nb_bdy
+         idx => idx_bdy(ib_bdy)
+
+         jgrd = 2                               ! cumulate u component contribution first 
+         DO jb = 1, idx%nblenrim(jgrd)
+            DO jk = 1, jpkm1
+               ii = idx%nbi(jb,jgrd)
+               ij = idx%nbj(jb,jgrd)
+               zubtpecor = zubtpecor + idx%flagu(jb) * ua(ii,ij, jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+            END DO
          END DO
-      END DO
-      jgrd = 3                               ! then add v component contribution
-      DO jb = 1, nblenrim(jgrd)
-         DO jk = 1, jpkm1
-            ii = nbi(jb,jgrd)
-            ij = nbj(jb,jgrd)
-            zubtpecor = zubtpecor + flagv(jb) * va(ii,ij, jk) * e1v(ii,ij) * fse3v(ii,ij,jk) 
+         jgrd = 3                               ! then add v component contribution
+         DO jb = 1, idx%nblenrim(jgrd)
+            DO jk = 1, jpkm1
+               ii = idx%nbi(jb,jgrd)
+               ij = idx%nbj(jb,jgrd)
+               zubtpecor = zubtpecor + idx%flagv(jb) * va(ii,ij, jk) * e1v(ii,ij) * fse3v(ii,ij,jk) 
+            END DO
          END DO
+
       END DO
       IF( lk_mpp )   CALL mpp_sum( zubtpecor )   ! sum over the global domain
@@ -118,21 +124,26 @@
       ! -------------------------------------------------------------
       ztranst = 0.e0
-      jgrd = 2                               ! correct u component
-      DO jb = 1, nblenrim(jgrd)
-         DO jk = 1, jpkm1
-            ii = nbi(jb,jgrd)
-            ij = nbj(jb,jgrd)
-            ua(ii,ij,jk) = ua(ii,ij,jk) - flagu(jb) * zubtpecor * umask(ii,ij,jk)
-            ztranst = ztranst + flagu(jb) * ua(ii,ij,jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+      DO ib_bdy = 1, nb_bdy
+         idx => idx_bdy(ib_bdy)
+
+         jgrd = 2                               ! correct u component
+         DO jb = 1, idx%nblenrim(jgrd)
+            DO jk = 1, jpkm1
+               ii = idx%nbi(jb,jgrd)
+               ij = idx%nbj(jb,jgrd)
+               ua(ii,ij,jk) = ua(ii,ij,jk) - idx%flagu(jb) * zubtpecor * umask(ii,ij,jk)
+               ztranst = ztranst + idx%flagu(jb) * ua(ii,ij,jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+            END DO
          END DO
-      END DO
-      jgrd = 3                              ! correct v component
-      DO jb = 1, nblenrim(jgrd)
-         DO jk = 1, jpkm1
-            ii = nbi(jb,jgrd)
-            ij = nbj(jb,jgrd)
-            va(ii,ij,jk) = va(ii,ij,jk) -flagv(jb) * zubtpecor * vmask(ii,ij,jk)
-            ztranst = ztranst + flagv(jb) * va(ii,ij,jk) * e1v(ii,ij) * fse3v(ii,ij,jk)
+         jgrd = 3                              ! correct v component
+         DO jb = 1, idx%nblenrim(jgrd)
+            DO jk = 1, jpkm1
+               ii = idx%nbi(jb,jgrd)
+               ij = idx%nbj(jb,jgrd)
+               va(ii,ij,jk) = va(ii,ij,jk) -idx%flagv(jb) * zubtpecor * vmask(ii,ij,jk)
+               ztranst = ztranst + idx%flagv(jb) * va(ii,ij,jk) * e1v(ii,ij) * fse3v(ii,ij,jk)
+            END DO
          END DO
+
       END DO
       IF( lk_mpp )   CALL mpp_sum( ztranst )   ! sum over the global domain
